<?php
//убираем вывод ошибок
error_reporting(0);

if (!$_POST) //
{
    die("error: no post");
}

include('inc/config.php');
include('inc/functions.php');

$errors = array();

$login = trim($_POST['login']);
$password = trim($_POST['pass']);

if (!checkLogin($login)){
    $errors[] = "login is incorrect/логин некорректен ".$login;
}

if (!checkPass($password)){
    $errors[] = ":password is incorrect/пароль некорректен ****";
}

if (count($errors)){
    showErrors($errors);
}

$base = new mysqli($dbhost, $dbuser, $dbpasswd, $dbname);
if ($base->connect_error) {
    showErrors(['Ошибка подключения (' . $base->connect_errno . ') '
       . $base->connect_error]);
}
$base->set_charset("utf8");

if (!$result=$base->query("SELECT `id`, `pass` FROM `".$table_prefix.
        "users` WHERE `login`='".$base->escape_string(trim($login))."';")){
    dieDBMessage();
}

if ($result->num_rows!=1){
    showErrors(['Логин неверен: '.$login]);
}
        
$row=$result->fetch_row();
$result->close();
$id = $row[0];

$passwd_hash = $row[1];
        
if (strlen($passwd_hash)==32){//Это пароль в виде md5 Надо проверить и заменить.
    if (md5($password)!=$passwd_hash){
        showErrors(['Пароль неверен']);
    }

    //Пароль верен, меняем на новый вид
    $passwd_hashed_new = password_hash($password, PASSWORD_DEFAULT);
    $base->query("UPDATE `".$table_prefix."users` SET `pass` = '".
            $passwd_hashed_new."' WHERE `id` = '".$id."';");
}
else if (!password_verify($password, $passwd_hash)){
    showErrors(['Пароль неверен']);
}

pushLastuse($id);
cleanBase();//Очищаем базу от неиспользуемых аккаунтов

//Все хорошо, поехали дальше
//ok нужен, т.к. позволяет обнаружить неверную конфигурацию сервера
$ok = $_POST['ok'];
if ($ok!='ok'){
    showErrors(['no ok ending']);
}
$action = $_POST['action'];
switch ($action){
    case 'download':        doDownload($id); break;
    case 'clean diary':     cleanDiary($id); break;
    case 'upload':          doUpload($id); break;
    case 'change pass':     changePass($id); break;
    case 'upload diary':  uploadDiary($id); break;
    
    default: { showErrors(["No such action"]); }
}
//На всякий случай тут окончание работы скрипта
exit();

function uploadDiary($id){
    global $table_prefix,$base;
    $json = $_POST['data'];
    $data = json_decode($json, $assoc=true);
    
    //Импортируем сахара
    $sugars = $data['sugars'];
    $values = array();
    for($dus=0;$dus<count($sugars);$dus++){
        $values[] = "$id, '".$base->escape_string($sugars[$dus]['time']).
                "', ".floatval($sugars[$dus]['sh1']).
                ", '".$base->escape_string($sugars[$dus]['comm']).
                "', 2";
    }
    if (count($values)>0){
        if (!$base->query("INSERT INTO `".$table_prefix."diary` (`iduser`, `time`, `sh1`, `comm`, `type`)
                        VALUES (".implode("), (", $values).");")){
            dieDBMessage();
        }
    }
    //Комментарии
    $comments = $data['comments'];
    $values = array();
    for($duc=0;$duc<count($comments);$duc++){
        $values[] = "$id, '".$base->escape_string($comments[$duc]['time']).
                "', '".$base->escape_string($comments[$duc]['comm']).
                "', 3";
    }
    if (count($values)>0){
        if (!$base->query("INSERT INTO `".$table_prefix."diary` (`iduser`, `time`, `comm`, `type`)
                        VALUES (".implode("), (", $values).");")){
            dieDBMessage();
        }
    }
    //тут сложные записи
    $menus = $data['menus'];
    for($dum=0;$dum<count($menus);$dum++){
        if (!$base->query("INSERT INTO `".$table_prefix."diary`
                    (`iduser`, `time`, `comm`, `sh1`, `sh2`, `k1`, `k2`, `k3`, `dose`,
                     `prot`, `fat`, `carb`, `gi`, `weight`, `type`)
                    VALUES ($id, '".
                    $base->escape_string($menus[$dum]['time'])."', '".
                    $base->escape_string($menus[$dum]['comm'])."', ".
                    floatval($menus[$dum]['sh1']).", ".
                    floatval($menus[$dum]['sh2']).", ".
                    floatval($menus[$dum]['k1']).", ".
                    floatval($menus[$dum]['k2']).", ".
                    floatval($menus[$dum]['k3']).", ".
                    floatval($menus[$dum]['dose']).", ".
                    floatval($menus[$dum]['prot']).", ".
                    floatval($menus[$dum]['fat']).", ".
                    floatval($menus[$dum]['carb']).", ".
                    intval($menus[$dum]['gi']).", ".
                    floatval($menus[$dum]['weight']).
                ", 1);")){
            dieDBMessage();
        }
        $dumAddedId = $base->insert_id;//Получили id Теперь можно добавлять продукты

        $values = array();
        $content = $menus[$dum]['products'];
        for($drp=0;$drp<count($content);$drp++){
            $values[] = "$id, '".$base->escape_string($content[$drp]['name'])."', ".//name
                    floatval($content[$drp]['prot']).", ".//prot
                    floatval($content[$drp]['fat']).", ".//fat
                    floatval($content[$drp]['carb']).", ".//carb
                    intval($content[$drp]['gi']).", ".//gi
                    floatval($content[$drp]['weight']).", ".//weight
                    intval($content[$drp]['issnack']).", ".//is snack
                    $dumAddedId;
        }
        if (count($values)>0){
            if (!$base->query("INSERT INTO `".$table_prefix."diaryrecords`
                        (`iduser`, `name`, `prot`, `fat`, `carb`, `gi`, `weight`, `issnack`, `owner`)
                        VALUES (".implode("), (", $values).");")){
                dieDBMessage();
            }
        }
    }
    echo 'ok';
}

function changePass($id){
    global $table_prefix,$base;
    $newpass = $_POST['newpass'];
    if (checkPass($newpass)){
        $passwd_hashed = password_hash($newpass, PASSWORD_DEFAULT);
        if (!$res = $base->query("UPDATE ".$table_prefix."users
                        SET pass = '".$passwd_hashed."'
                            WHERE id = $id;")){
            dieDBMessage();
        }
        $res->close();
        
        if (!$res = $base->query("SELECT email, login FROM ".$table_prefix."users WHERE id=$id")){
            dieDBMessage();
        }

        if ($res->num_rows===1){
                $row = $res->fetch_row();
                $email = $row[0];
                $login = $row[1];
                $res->close();

                $admin = 'diacalc@ya.ru';
                $subject = 'Изменение учетной записи программы DiaCalc';
                $message2user =
"Кто то, возможно Вы, изменил учетную запись, позволяющую
использовать интернет возможности программы DiaCalc http://diacalc.org/
Если это были не Вы, то ничего не предпринимайте, учетная запись будет удалена
автоматически по прошествии некоторого времени.

Если это были Вы, то параметры учетной записи следующие:
Логин: ".$login."
пароль ".$newpass."
Сохраните это письмо!

Если Вы потеряете пароль, то его можно восстановить по адресу
http://diacalc.org/dbwork/recovery.php
Изменить email можно по адресу http://diacalc.org/dbwork/login.php

Удачи!";
                mail_utf8($email,$subject,$message2user,$admin);
                echo 'ok';

            }
            else{
                showErrors(["no such id found<br>"]);
            }
    }
    else{
        showErrors(['password is incorrect/новый пароль не удовлетворяет условиям, пароль оставлен прежний']);
    }
}

function doUpload($id){
    $json = $_POST['data'];
    $data = json_decode($json, $assoc=true);
    
    if (array_key_exists("menu", $data)){
        uploadMenu($id,$data['menu']);
    }
    if (array_key_exists("products", $data)){
        uploadProducts($id,$data['products']);
    }
    echo 'ok';
}
function uploadProducts($id,$data){
    global $table_prefix, $base;
    
    if (!$base->query("DELETE FROM `".$table_prefix."groups` WHERE iduser=".$id.";") ||
        !$base->query("DELETE FROM `".$table_prefix."prods` WHERE iduser=".$id.";") ||
        !$base->query("DELETE FROM `".$table_prefix."cmpl` WHERE iduser=".$id.";")){
        dieDBMessage();
    }
    for($g=0;$g<count($data);$g++){
        if (!$base->query("INSERT INTO `".$table_prefix."groups` (`iduser`, `name`, `sortind`)
                    VALUES ($id, '".$base->escape_string($data[$g]['name']).
                    "', ".intval($data[$g]['sortInd']).");")){
            dieDBMessage();
        }
        $grid = $base->insert_id;//Получили id Теперь можно добавлять продукты
        $prods = $data[$g]['prods'];//Это массив
        for($p=0;$p<count($prods);$p++){
            if (!$base->query("INSERT INTO ".$table_prefix."prods
                 (`iduser`, `idgroup`, `name`, `prot`, `fat`, `carb`, `gi`, `weight`, `cmpl`, `usage`)
                 VALUES ($id, $grid, '".$base->escape_string($prods[$p]['name']).
                 "', ".floatval($prods[$p]['prot']).
                 ", ".floatval($prods[$p]['fat']).
                 ", ".floatval($prods[$p]['carb']).
                 ", ".intval($prods[$p]['gi']).
                 ", ".floatval($prods[$p]['weight']).
                 ", ".intval($prods[$p]['complex']).
                 ", ".intval($prods[$p]['usage']).
                 ");") ){
                dieDBMessage();
            }
            if (intval($prods[$p]['complex'])){//Сложный продукт
                $prid = $base->insert_id;
                $content = $prods[$p]['content'];
                $values = array();
                for($c=0;$c<count($content);$c++){
                    $values[] = "$id, $prid, '".
                        $base->escape_string($content[$c]['name']).
                       "', ".floatval($content[$c]['prot']).
                        ", ".floatval($content[$c]['fat']).
                        ", ".floatval($content[$c]['carb']).
                        ", ".intval($content[$c]['gi']).
                        ", ".floatval($content[$c]['weight']);
                }
                if (count($values)>0){
                    if (!$base->query("INSERT INTO ".$table_prefix."cmpl
                            (`iduser`, `idprod`, `name`, `prot`, `fat`, `carb`, `gi`, `weight`)
                            VALUES (".implode("), (", $values).");") ){
                        dieDBMessage();
                    }
                }
            }
        }
    }
}
function uploadMenu($id,$data){
    global $table_prefix, $base;
    $coefs = $data['coefs'];
    $rows = $data['rows'];
    
    //Чистим меню на сервере
    if (!$res = $base->query("DELETE FROM `".$table_prefix."menus` WHERE iduser=".$id.";")){
        dieDBMessage();
    }
    $values = array();
    for($i=0;$i<count($rows);$i++){
        $values[] = "$id, '".$base->escape_string($rows[$i]['name'])."' , ".
                    floatval($rows[$i]['prot'])." , ".
                    floatval($rows[$i]['fat'])." , ".
                    floatval($rows[$i]['carb'])." , ".
                    intval($rows[$i]['gi'])." , ".
                    floatval($rows[$i]['weight'])." , ".
                    intval($rows[$i]['issnack']);
    }
    if (count($rows)>0){
        if (!$base->query("INSERT INTO `".$table_prefix."menus`
        (`iduser`, `name`, `prot`, `fat`, `carb`, `gi`, `weight`, `issnack`)
        VALUES (".implode("), (", $values).");")){
            dieDBMessage();
        }
    }
    
    if (!$base->query("UPDATE `".$table_prefix."users`
                 SET `k1`='".floatval($coefs['k1']).
                "', `k2`='".floatval($coefs['k2']).
                "', `k3`='".floatval($coefs['k3']).
                "', `sh1`='".floatval($coefs['sh1']).
                "', `sh2`='".floatval($coefs['sh2']).
                "' WHERE id=".$id.";")){
        dieDBMessage();
    }
}

function cleanDiary($id){
    global $table_prefix,$base;
    if (!$base->query("DELETE FROM `".$table_prefix."diary` WHERE iduser=$id;") ||
        !$base->query("DELETE FROM `".$table_prefix."diaryrecords` WHERE iduser=$id;") ){
        
        dieDBMessage();
    }
    echo('ok');//Короткие функции пусть возвращают что угодно, но не error
}

function doDownload($id){
    $answer = array(
        ver => getVersions()
    );
    //Получаем массив entity
    $entity = $_POST['entity'];
    for($i=0;$i<count($entity);$i++){
        switch ($entity[$i]){
            case 'menu' : $answer['menu'] = downloadMenu($id); 
                break;
            case 'products': $answer['products'] = downloadProducts($id);
                break;
            case 'diary': $answer['diary'] = downloadDiary($id);//diary with snacks!
                break;
        }
    }
    echo json_encode($answer);
}

function downloadMenu($id){
    global $table_prefix,$base;
    
    if (!$res = $base->query("SELECT `name`, `prot`, `fat`, `carb`, `gi`, `weight`, `issnack`
        FROM `".$table_prefix."menus` WHERE iduser=$id;")){
        dieDBMessage();
    }
    
    $lines = array();
    while ($row = $res->fetch_assoc()){
        $lines[] = array(
            name => $row['name'],
            prot => $row['prot'],
            fat =>  $row['fat'],
            carb => $row['carb'],
            gi =>   $row['gi'],
            weight=>$row['weight'],
            issnack=>$row['issnack']
        );
    }
    $res->close();
    if (!$res = $base->query("SELECT `k1`, `k2`, `k3`, `sh1`, `sh2`
        FROM `".$table_prefix."users` WHERE id=$id;")){
        dieDBMessage();
    }
    if (!$row=$res->fetch_assoc()){
        dieDBMessage();
    }
    $coefs = array(
        k1 => $row['k1'],
        k2 => $row['k2'],
        k3 => $row['k3'],
        sh1=> $row['sh1'],
        sh2=> $row['sh2']
    );    
    $res->close();
    
    $menu = array(
        rows  => $lines,
        coefs => $coefs
    );
    
    return $menu;
}
function downloadProducts($id){
    global $table_prefix,$base;
    //Отдаем три таблицы группы, продукты, сложные
    if (!$res = $base->query("SELECT `name`, `id`
        FROM `".$table_prefix."groups` WHERE iduser=$id ORDER BY `sortind`;")){
        dieDBMessage();
    }
    $groups = array();
    while ($row = $res->fetch_assoc()){
        $groups[] = array( 
            name    => $row['name'],
            id      => $row['id']
        );
    }
    $res->close();
    
    if (!$res = $base->query("SELECT `name`, `prot`, `fat`, `carb`, `gi`, `weight`, `cmpl`, `usage`, `id`, `idgroup`
            FROM `".$table_prefix."prods` WHERE iduser=$id ORDER BY `idgroup`, `name`;")){
        dieDBMessage();
    }
    
    $products = array();
    while($row = $res->fetch_assoc()){
        $products[] = array(
            name    => $row['name'],
            prot    => $row['prot'],
            fat     => $row['fat'],
            carb    => $row['carb'],
            gi      => $row['gi'],
            weight  => $row['weight'],
            cmpl    => $row['cmpl'],
            usage   => $row['usage'],
            id      => $row['id'],
            idgroup => $row['idgroup']
        );
    }
    $res->close();
    
    if (!$res = $base->query("SELECT `name`, `prot`, `fat`, `carb`, `gi`, `weight`, `idprod`
            FROM `".$table_prefix."cmpl` WHERE iduser=$id ORDER BY `idprod`, `name`;")){
        dieDBMessage();
    }
    
    $complex = array();
    while($row = $res->fetch_assoc()){
        $complex[] = array(
            name    => $row['name'],
            prot    => $row['prot'],
            fat     => $row['fat'],
            carb    => $row['carb'],
            gi      => $row['gi'],
            weight  => $row['weight'],
            idprod  => $row['idprod']
        );
    }
    $res->close();
    
    $products_base = array(
        groups   => $groups,
        products => $products,
        complex  => $complex
    );
    return $products_base;
}
function downloadDiary($id){
    global $table_prefix,$base;
    //В начале простые записи
    //(`iduser`, `time`, `sh1`, `comm`, `type`)
    if (!$res = $base->query("SELECT `comm`, `time`, `sh1`
        FROM `".$table_prefix."diary` WHERE iduser=$id AND `type`=2;")){
        dieDBMessage();
    }
    
    $diarySugars = array();
    while ($row = $res->fetch_assoc()){
        $diarySugars[] = array(
            comm    => $row['comm'],
            time    => $row['time'],
            sh1     => $row['sh1']
        );
    }
    $res->close();
    
    //Теперь коментарии
    //(`iduser`, `time`, `comm`, `type`)
    if (!$res = $base->query("SELECT `comm`, `time`
        FROM `".$table_prefix."diary` WHERE iduser=$id AND `type`=3;")){
        dieDBMessage();
    }
    
    $diaryComments = array();
    while ($row = $res->fetch_assoc()){
        $diaryComments[] = array(
            comm    => $row['comm'],
            time    => $row['time']
        );
    }
    $res->close();
    
    //(`iduser`, `time`, `comm`, `sh1`, `sh2`, `k1`, `k2`, `k3`, `dose`,
                         //`prot`, `fat`, `carb`, `gi`, `weight`, `type`)
    if (!$res = $base->query("SELECT `comm`, `id`, `time`, `sh1`, `sh2`, `k1`, `k2`, `k3`, `dose`,
        `prot`, `fat`, `carb`, `gi`, `weight`
        FROM `".$table_prefix."diary` WHERE iduser=$id AND `type`=1;")){
        dieDBMessage();
    }
    
    $diaryMenus = array();
    while ($row = $res->fetch_assoc()){//14-элементов
        $diaryMenus[] = array(
            comm    => $row['comm'],
            id      => $row['id'],
            time    => $row['time'],
            sh1     => $row['sh1'],
            sh2     => $row['sh2'],
            k1      => $row['k1'],
            k2      => $row['k2'],
            k3      => $row['k3'],
            dose    => $row['dose'],
            prot    => $row['prot'],
            fat     => $row['fat'],
            carb    => $row['carb'],
            gi      => $row['gi'],
            weight  => $row['weight']            
        );
    }
    $res->close();
    
    //(`iduser`, `name`, `prot`, `fat`, `carb`, `gi`, `weight`, `owner`)
    if (!$res = $base->query("SELECT `name`, `prot`, `fat`, `carb`, `gi`, `weight`, `issnack`, `owner`
           FROM `".$table_prefix."diaryrecords` WHERE iduser=$id;")){
        dieDBMessage();
    }
    
    $diaryRecords = array();
    while ($row = $res->fetch_assoc()){//7-элементов
        $diaryRecords[] = array(
            name    => $row['name'],
            prot    => $row['prot'],
            fat     => $row['fat'],
            carb    => $row['carb'],
            gi      => $row['gi'],
            weight  => $row['weight'],
            issnack => $row['issnack'],
            owner   => $row['owner']
        );
    }
    $res->close();
    
    //Потом нужно будет удалить записи из дневника
    //чтобы заново не посылать логин и пароль стартуем сессию
    //session_start();
    
    $diary = array(
        comments => $diaryComments,
        menus    => $diaryMenus,
        sugars   => $diarySugars,
        records  => $diaryRecords
    );
    return $diary;
}

function getVersions(){
    include_once('inc/version.php');
    $ver = array(
        dcj     => VER_DCJ,
        dcjm    => VER_DCJM,
        dcjmt   => VER_DCJM_TOUCH
    );
    return $ver;
}
function showErrors($errors){
    echo 'errors:<br>';
    foreach($errors as $error){
        echo $error.'<br>';
    }
    exit();
}
function dieDBMessage(){
    global $base;
    showErrors(['Ошибка при запросе к БД']);
}

function pushLastuse($id){
    global $table_prefix,$base;
    if(!$base->query("UPDATE ".$table_prefix."users SET lastuse=".time()." WHERE id=".$id.";")){
        dieDBMessage();
    }
}

function cleanBase(){
    global $table_prefix,$one_year,$base;
    $year_ago = time() - $one_year;
    
    if ($res = $base->query("SELECT id FROM `".$table_prefix."users` WHERE `lastuse`<$year_ago;")){
        while ($row = $res->fetch_array()) {
            deleteUser($row[0]);
        }
        $res->close();
    }else{
        dieDBMessage();
    }
}

function deleteUser($id){
   global $table_prefix,$base;
   if ( !$base->query("DELETE FROM `".$table_prefix."cmpl` WHERE iduser=$id;")  ||
        !$base->query("DELETE FROM `".$table_prefix."prods` WHERE iduser=$id;") ||
        !$base->query("DELETE FROM `".$table_prefix."groups` WHERE iduser=$id;") ||
        !$base->query("DELETE FROM `".$table_prefix."menus` WHERE iduser=$id;") ||
        !$base->query("DELETE FROM `".$table_prefix."diary` WHERE iduser=$id;") ||
        !$base->query("DELETE FROM `".$table_prefix."diaryrecords` WHERE iduser=$id;") ||
        !$base->query("DELETE FROM `".$table_prefix."users` WHERE id=$id;") ){
    dieDBMessage();
   }
}
